@import 'variables';
@import 'functions';

@mixin app-button($passed: (), $context: null, $deep: false, $strategy: 'changes') {

  $defs: (
          corner: $jnt-corner-large,
          padding: $jnt-gutter-small,
          background-color: $jnt-primary-color,
          color: $jnt-white-color
  );

  $vars: $passed;
  $declare: false;
  $wrapper: null;

  @if $deep {
    $wrapper: '::ng-deep';
  }

  @if $passed == () or $strategy == 'merge' {
    $vars: recursive-map-merge($defs, $passed);
    $declare: true;
  }

  :host, #{$context} {
    @if $declare {
      display: inline-block;
    }
  }

  #{$context} #{$wrapper} button {
    border-radius: map-get($vars, corner);
    padding: map-get($vars, padding);
    background-color: map-get($vars, background-color);
    color: map-get($vars, color);
  }
}
